// Завдання

// Реалізувати функцію створення об'єкта "юзер". Завдання має бути виконане на чистому Javascript без використання бібліотек типу jQuery або React.

// Технічні вимоги:
// Написати функцію createNewUser(), яка буде створювати та повертати об'єкт newUser.
// При виклику функція повинна запитати ім'я та прізвище.
// Використовуючи дані, введені юзером, створити об'єкт newUser з властивостями firstName та lastName.
// Додати в об'єкт newUser метод getLogin(), який повертатиме першу літеру імені юзера, з'єднану з прізвищем, все в нижньому регістрі (наприклад, Ivan Kravchenko → ikravchenko).
// Створити юзера за допомогою функції createNewUser(). Викликати у цього юзера функцію getLogin(). Вивести у консоль результат виконання функції.
// Необов'язкове завдання підвищеної складності
// Зробити так, щоб властивості firstName та lastName не можна було змінювати напряму. Створити функції-сеттери setFirstName() та setLastName(), які дозволять змінити дані властивості.


let createNewUser = () => {

    let askGivenName = prompt('Type your name here');
    let askFamilyName = prompt('Type your surname here');

    let newUser = {
        // firstName: askGivenName, // рішення без додаткового завдання
        // lastName: askFamilyName,
        getLogin: function () {
            return (this.firstName[0] + this.lastName).toLowerCase();
        },
        setFirstName: function () { // додаткове завдання
            this.firstName = askGivenName;
            return 
        },
        setLastName: function () {
            this.lastName = askFamilyName;
            return         
        }
    };

    // console.log(newUser);
    newUser.setFirstName();
    newUser.setLastName();
    console.log(newUser.getLogin());
    return newUser;
}

createNewUser();

// Опишіть своїми словами, що таке метод об'єкту
// - Метод JavaScript - це дія, яку можна віконувати з обʼєктами

// Який тип даних може мати значення властивості об'єкта?
// - будь-який тип даних

// Об'єкт це посилальний тип даних. Що означає це поняття?
// - Посилальний тип – це внутрішній тип мови.
// Читання властивості, наприклад, крапкою . в obj.method() повертає не саме значення властивості, але спеціальне значення “посилального типу”, яке зберігає як значення властивості, так і об’єкт, з якою він був взятий.
// Це використовується для подальшого виклику методу за допомогою (), щоб отримати об’єкт і встановити this до цього.
// Для всіх інших операцій, посилальний тип автоматично стає значенням властивості (функцією у нашому випадку).
// Вся ця механіка прихована від наших очей. Це лише важливо в тонких випадках, наприклад, коли метод отримується динамічно з об’єкта, використовуючи вираз.